# PSF-LoginServer - master - net.psforever.objects.geometry.d3.Ray
PSF - LoginServer - master - net.psforever.objects.geometry.d3.Ray
Keywords: PSF LoginServer master net.psforever.objects.geometry.d3.Ray

PSF-LoginServer - master < Back


# Packages

-  package root
  Definition Classes
    root
-  package net
  Definition Classes
    root
-  package psforever
  Definition Classes
    net
-  package objects
  Definition Classes
    psforever
-  package geometry
  Definition Classes
    objects
-  package d3
  Definition Classes
    geometry
- Cuboid
- Cylinder
- Geometry3D
- Line
- Point
- Ray
- Segment
- Sphere
- VolumetricGeometry

c

net.psforever.objects.geometry.d3

# Ray 

###
Companion object Ray

#### final case class Ray(p: Point, d: Vector3) extends Geometry3D with geometry.Line with Product with Serializable

The instance of a geometric coordinate position and a specific direction from that position. Rays are like mathematical lines in that they have infinite length; but, that infinite length is only expressed in a single direction, rather than proceeding in both a direction and its opposite direction from a target point. Infinity just be like that. Additionally, the point is not merely any point on the ray used to assist defining it and is instead considered the clearly-defined origin of the ray.

p

  the point of origin

d

  the direction

Source
  Ray.scala

Linear Supertypes
Serializable, Product, Equals, geometry.Line, Slope, Geometry3D, PrimitiveGeometry, AnyRef, Any

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Ray
2. Serializable
3. Product
4. Equals
5. Line
6. Slope
7. Geometry3D
8. PrimitiveGeometry
9. AnyRef
10. Any

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Instance Constructors

1.  new Ray(p: Point, d: Vector3)

   p

     the point of origin

   d

     the direction

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##: Int
   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
4.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
5.  def center: Point

   The centroid of the geometry.

   The centroid of the geometry.

   returns

     a point

   Definition Classes
     Ray → Geometry3D → PrimitiveGeometry
6.  def clone(): AnyRef
   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
7.  val d: Vector3

   The slope itself.

   The slope itself.

   returns

     a `Vector3` entity

   Definition Classes
     Ray → Slope
8.  final def eq(arg0: AnyRef): Boolean
   Definition Classes
     AnyRef
9.  def finalize(): Unit
   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.Throwable])
10.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
11.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
12.  def length: Float

    The length of a mathematical line is infinite.

    The length of a mathematical line is infinite.

    returns

      The length of the slope

    Definition Classes
      Line → Slope
13.  def moveCenter(point: geometry.Point): Geometry3D

    Move the centroid of the shape to the given point

    Move the centroid of the shape to the given point

    point

      the new center point

    returns

      geometry centered on the new point; ideally, should be the same type of geometry as the original object

    Definition Classes
      Ray → Geometry3D → PrimitiveGeometry
14.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
15.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
16.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
17.  val p: Point
    Definition Classes
      Ray → Line
18.  def productElementNames: Iterator[String]
    Definition Classes
      Product
19.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
20.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
21.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
22.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Inherited from Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from geometry.Line

### Inherited from Slope

### Inherited from Geometry3D

### Inherited from PrimitiveGeometry

### Inherited from AnyRef

### Inherited from Any

### Ungrouped